# Advanced Namespace Tools blog
### 16 January 2017

## Recent, Ongoing, and Upcoming Plan 9 Projects

I spend plenty of words here talking about my own Plan 9 coding and setups, but there are many other people doing interesting work using 9front. I wanted to list some other recently completed, ongoing, and upcoming software being created. This isn't a comprehensive list, just things I have seen people mention in irc that they are working on. If you'd like your project included here, or want to update the information I've posted or have me post a link to something, just let me know. Remember that this is mostly work-in-progress and some projects may evolve to a different form, or be left to simmer on the proverbial back burner. In alphabetical order by irc handle:

* Aiju has been working on FPGA software for Plan 9. His "vlt" parses verilog, producing lint output, and can generate verilog interconnects. He also has been working on a new hdl and a plan 9 based compiler. He provided this link: [https://github.com/aiju/hdl/tree/master/tools](https://github.com/aiju/hdl/tree/master/tools)

* Deuteron has been working on porting 9front to Beaglebone Black. I recall him saying that he is getting pretty far into the boot process now, but "Caches are still crazy."

* Joe9 has gotten the Idris language working for simple programs via an ape port.

* Jpm\_ is continuing work on ircs, his irc client. It is already quite usable, I've irc'd from it myself. The code is at [http://www.plan9.fi/src/ircs.tgz](http://www.plan9.fi/src/ircs.tgz) and the manpage is at [http://www.plan9.fi/ircs.txt](http://www.plan9.fi/ircs.txt).

* Mischief has been working on improving 9front support for Xen. He reports having 9front mostly running as a Xen domU under netbsd dom0 on his x200.

* Mveety has been working on "ngfs", a new storage volume manager combining some design ideas inspired by zfs and mirroring and concatenation features similar to the existing Plan 9 devfs. He recently hit the landmark of being able to boot from it. He is also continuing work on a ports tree for 9front and invites submissions at [http://code.9front.org/hg/ports/](http://code.9front.org/hg/ports/). You can also check out his 9front hosted personal website at [http://mveety.com](http://mveety.com).

* Ori_B is continuing work on the Myrddin language, which supports 9front. The 9front repository is at [https://bitbucket.org/oridb/mc](https://bitbucket.org/oridb/mc) and the main project website at [http://myrlang.org/](http://myrlang.org/). The language is already usable and is described as "a systems language with manual memory management, a strong type system with parametric polymorphism, and a well engineered standard library".

* Pr is working on a games/chess engine. It will speak the Universal Chess Interface protocol. He says he is trying to avoid getting bogged down in unnecessary micro-optimization.

* Qwx is working on a port of Wolfenstein 3D, to go along with his earlier ports of Quake 1 and 2. He's also hoping to improve the Quake ports with proper networking. They can be found via 9p in his contrib at /n/contrib/qwx after "9fs 9front" from a 9front system.

* Sam-d is working on a "restfs" to help bridge between the Plan 9 world of the 9p protocol, and the http/json protocols that much of the rest of the computing world uses. Restfs is intended to take a file describing a REST api, and produce a fileserver that can interact with it, and to make any JSON into an editable filesystem. It sounds ambitious but exciting to me. He is even hoping to add WADL conversion to generate the description file, although he isn't certain that is feasible.

* Spew recently completed an emulator for Knuth's MIX language, used for the examples in The Art of Computer Programming. It has been added to the main 9front distribution. His current project is a concurrent c compiler.

Along with all this, Cinap Lenrek and others have been keeping up a steady stream of improvements and bugfixes to 9front itself. Good luck to everyone developing in Plan 9, may your Twalks always take you where you want to go and your Treads always return the data you need.
